// Header file for the library Quicktag.dll
// Copyright 1999 Cogilex R&D inc.

// DO NOT MODIFY THIS FILE
// DO NOT DISTRIBUTE THIS FILE

// PORTABILITY ISSUES
// All functions use standard calling conventions

//---------------------------------------------------------------------------
#ifndef QuickTagH
#define QuickTagH
//---------------------------------------------------------------------------

/*
InitializeQuickTag must be called once to initialize the library. theFileName
should contain the complete path to the data file "Quicktag.dat".
Returns 1 if successful, 0 otherwise.
*/
int __declspec(dllimport) __stdcall InitQuickTag (char* aDataFile);

// This is the main tagging-disambiguation function
int __declspec(dllimport) __stdcall QuickTag(char* aText, char* theOutFile);

/*
A call to QuickTag will tag and disambiguate "aText" and put the result
into "theOutFile".  QuickTag returns the number of words found, 0 if unseccessful

The result file will contain one line per word formatted
in four fields separated by tabs:

	Field 1:	the original word;
	Field 2:	the root form of the word
	Field 3:	The syntactical role
	Field 4:	the main part of speech
	Field 5:	modifier for the part of speech	(can be empty)

	Field 3, the syntactical role, is a value among
		N	used as a noun
		V	used as a verb
		Adj	used as an adjective
		Adv	used as an adverb
		Prep	used as a preposition
		*	used as a functional word
		#	used as a punctuation or symbol

	Field 4 and 5 can have the following values

	N					;nouns
		N(Plural)			;plural nouns: children, feet, men,...
		N(Proper)			;proper nouns
	V					;verbs
		V(Pres)			;present tense 3rd pers. sing.: has, is, goes,...
		V(Past)				;past tense: ate, knew, took, etc...
	PP					;past participles (can be used as Adj in field 3)
	Ing					;ing forms (can be used as N in field 3)
	Adj					;adjectives
		Adj(Ordinal)			;first, second, third, etc...
		Adj(Comparative)	;better, worse,...
		Adj(Superlative)	;best, worst,...
	Adv					;adverbs
		Adv(Loc)			;downstairs, home, indoors,...
		Adv(Neg)			;not.
	Wh					;how,if,when,whether,why.
	Modal					;can,could,must,should,...
	Pro					;pronouns (not used alone)
		Pro(definite)		;I,you,he,me,her,himself,...
		Pro(Indefinite)		;anybody,everybody,nobody,anyone,...
		Pro(Possessive)		;mine,yours,ours,...
		Pro(Wh)				;whatever,whichever,who,whoever,whom,whomever.
	Det 				;determiners (not used alone)
		Det(IndefiniteArticle)	;a,an;
		Det(DefiniteArticle)	;the.
		Det(Cardinal)			;one,two,three,...
		Det(Wh)					;what,whiche,whose.
		Det(Quantifier)			;any,every,few,many,...
		Det(Posessive)			;my,your,his,her,...
		Det(Demonstrative)		;that,this,these,those.
	Misc				;various (not used alone)
		Misc(Index)				;ago,o'clock,a.m.,...
		Misc(Interjection)		;interjections: ah,eh,gee,gosh,...
		Misc(Measure)			;deep,high,long,old,..
		Misc(Letter)			;A,B,...
		Misc(Abbreviation)
		Misc(To)
		Misc(French)			; functional french words
		Misc(Predet)				;all,both,each,...
	Prep				;prepositions
		Prep(VComp)			; can take verbal comps, for, of, by, in, ...
		Prep(Wh)				;whenever,where,wherever
		Prep(French)				; French preposition (de, du, ...)
	Conj				;conjonctions: and, org
	Num 				;numbers
*/


#endif