'
' MAILER.BAS
'
' Edit EMAIL.INC before compiling.
' Compile & link: PBCC MAILER.BAS
'

$INCLUDE "SEE32.PBI"
$INCLUDE "KEYCODE.PBI"

GLOBAL ArgVal() As String
$INCLUDE "GETARGS.PBI"

Sub ShowError(Code As Long)
Dim N As Long
Dim Buffer As Asciiz * 128
N = seeErrorText(0,Code,Buffer,128)
PRINT Buffer
End Sub

FUNCTION PbMain() AS LONG
$INCLUDE "EMAIL.INC"
Dim N As Integer
Dim Code As Long
Dim ArgVal(10) As String
Dim NullString As Asciiz * 2
Dim Buffer As Asciiz * 30
Dim Version As Integer
Dim DiagFile As Asciiz * 64
Dim A As String
Dim B As String
Dim C As String
Dim EmailMsg As Asciiz * 512
Dim EmailSubj As Asciiz * 64
Dim EmailTo As Asciiz * 64
Dim EmailAttach As Asciiz * 64

Dim Quote As String

PRINT "MAILER 01/24/2000"

NullString = Chr$(0)
Quote = Chr$(&H22)

' get command line arguments
N = GetArgs()

IF (N <> 3) AND (N <> 4) THEN
  PRINT "Usage: MAILER message_file subject email_addr [attach_file]"
  PRINT "   eg: MAILER ";
  PRINT Quote;"this is the msg";Quote;" ";
  PRINT Quote;"this is the subj";Quote;" ";
  PRINT Quote;"<mike@marshallsoft.com>";Quote
  PRINT "   eg: MAILER ";
  PRINT Quote;"@test.mai";Quote;
  PRINT " test ";
  PRINT Quote;"<mike@marshallsoft.com>";Quote;" ";
  PRINT "test.zip"
  Exit Function
END IF

' gets ASCIIZ version of argument strings
EmailTo = ArgVal(3)
EmailSubj = ArgVal(2)
EmailMsg = ArgVal(1)
IF N = 4 THEN
  EmailAttach = ArgVal(4)
ELSE
  EmailAttach = ""
END IF

' attach SEE
Code = seeAttach(1,%SEE_KEY_CODE)
If Code < 0 Then
  PRINT "Cannot attach SEE. Check SEE_KEY_CODE"
  Exit Function
End If
' display SEE version
Version = seeStatistics(0,%SEE_GET_VERSION)
C = LTRIM$(Str$(&H0F AND Version))
SHIFT RIGHT Version, 4
B = LTRIM$(Str$(&H0F AND Version))
SHIFT RIGHT Version, 4
A = LTRIM$(Str$(&H0F AND Version))
PRINT "SEE Version " + A + "." + B + "." + C

' define diagnostics log file
DiagFile = "mailer.log"
Code = seeStringParam(0,%SEE_LOG_FILE, DiagFile)
' enable quoting
Code = seeIntegerParam(0, %SEE_QUOTED_PRINTABLE, %QUOTED_PLAIN)
' check "To" email address
If Len(EmailTo) = 0 Then
  PRINT "Missing 'Email To' address..."
  Code = seeClose(0)
  Code = seeRelease()
  Exit Function
Else
  Code = seeVerifyFormat(EmailTo)
  If Code < 0 Then
    ' error in format
    Call ShowError(Code)
    Code = seeClose(0)
    Code = seeRelease()
    Exit Function
  End If
End If

' connect to the SMTP server
PRINT "Connecting to ";SMTP_HOST_NAME
Code = seeSmtpConnect(0,SMTP_HOST_NAME, YOUR_EMAIL_ADDR, NullString)
IF Code < 0 THEN
  Call ShowError(Code)
  Code = seeClose(0)
  Code = seeRelease()
  EXIT Function
END IF
Code = seeDebug(0,%SEE_GET_SERVER_IP, Buffer, 30)
PRINT "Connected to " + Buffer

' send the email
PRINT Time$;" Sending email, please wait..."
Code = seeSendEmail(0,EmailTo, NullString, NullString,EmailSubj,EmailMsg,EmailAttach)
If Code < 0 Then
  'error in format
  Call ShowError(Code)
   Code = seeClose(0)
  Code = seeRelease()
  Exit Function
End If
PRINT Time$;" Email sent."
Code = seeClose(0)
Code = seeRelease()
END FUNCTION
