      PROGRAM MAILER
C
C     Compile and link with
C
C        amake -f mailer._a_
C
      IMPLICIT NONE
      INCLUDE 'SEE4F.INC'
      INCLUDE 'KEYCODE.INC'

      CHARACTER*64 SmtpHost
      CHARACTER*64 EmailFrom
      CHARACTER*64 EmailTo
      CHARACTER*64 Subject
      CHARACTER*64 Message
      CHARACTER*64 Attachment
      INTEGER*4 Code

C     *** IMPORTANT *****************************************
C     *** Edit these next 3 lines with your SMTP server name
C     *** and email addresses. See Users Manual (SEE4F_U.TXT)
C     *******************************************************

      SmtpHost = 'smtp_host_name' // CHAR(0)
      EmailFrom = 'your_email_address' // CHAR(0)
      EmailTo = 'receipients_email_address' // CHAR(0)

C     *****************************************************

C     *** define remaining email parameters

      Subject = 'MAILER Test' // CHAR(0)
      Message = 'Mailed from MAILER program.' // CHAR(0)
      Attachment = CHAR(0)

CCC      *** specify filename of message (note '@' below)
CCC      Message = '@c:\temp\test.mai' // CHAR(0)
CCC      Attachment = 'c:\temp\test.zip' // CHAR(0)

C     *** attach SEE

      Code = seeAttach(VAL(1), VAL(SEE_KEY_CODE))
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeAttach fails (', Code, '). Check your key code.'
        STOP
      END IF

C     *** connect to SMTP server

      WRITE(*,*) 'Connecting to ', SmtpHost
      Code = seeSmtpConnect( VAL(0), ! channel 0
     1    VAL(LOC(SmtpHost)),        ! SMTP Host name
     2    VAL(LOC(EmailFrom)),       ! Your email address
     3    VAL(0) )                   ! ReplyTo header
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeSmtpConnect returns error ', Code
        CALL ErrorExit(Code)
      END IF

C     *** send email

      WRITE(*,*) 'Sending email...'
      Code = seeSendEmail( VAL(0),       ! Channel 0
     1    VAL(LOC(EmailTo)),             ! Receipient's email address
     2    VAL(0),                        ! no CC list
     3    VAL(0),                        ! no BCC list
     4    VAL(LOC(Subject)),             ! the subject
     5    VAL(LOC(Message)),             ! the message
     6    VAL(LOC(Attachment)) )         ! the attachment

      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeSendMail returns error ', Code
        CALL ErrorExit(0)
      END IF

C     *** close connection

      Code = seeClose(VAL(0))

C     *** release SEE

      Code = seeRelease()

      STOP
      END

C     *** Error exit subroutine

      SUBROUTINE ErrorExit(ErrCode)
      INTEGER*4 ErrCode
      CHARACTER*64 Buffer
      INTEGER*4 Code
      IF(ErrCode.LT.0) THEN
C       *** clear Buffer
        Buffer = REPEAT(' ', 64)
C       *** get error text into Buffer & print message
        Code = seeErrorText(VAL(0), VAL(ErrCode),
     1                      VAL(LOC(Buffer)),VAL(64))
        WRITE(*,*) Buffer
      END IF
      Code = seeClose(VAL(0))
      Code = seeRelease()
      STOP
      END
