      PROGRAM READER
C
C     Compile and link with
C
C        amake -f reader._a_
C
      IMPLICIT NONE
      INCLUDE 'SEE4F.INC'
      INCLUDE 'KEYCODE.INC'

      CHARACTER*64 Pop3Host
      CHARACTER*64 Pop3User
      CHARACTER*64 Pop3Pass
      CHARACTER*40 FileName
      CHARACTER*40 EmailDir
      CHARACTER*40 AttachDir

      INTEGER*4 Code
      INTEGER*4 NbrMsg
      INTEGER*4 MsgSize
      INTEGER*4 MsgNbr
      INTEGER*4 Counter

C     *** IMPORTANT *****************************************
C     *** Edit these next 3 lines with your POP3 server name,
C     *** user name and password. For more information, see
C     *** the Users Manual (SEE4F_U.TXT)
C     *******************************************************

      Pop3Host = 'pop3_host_name' // CHAR(0)
      Pop3User = 'pop3_user_name' // CHAR(0)
      Pop3Pass = 'pop3_password'  // CHAR(0)

C     *** specify directories for email and for attachments
      EmailDir  = 'c:\temp' // CHAR(0)
      AttachDir = 'c:\temp' // CHAR(0)

C     *** attach SEE
      Code = seeAttach(VAL(1), VAL(SEE_KEY_CODE))
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeAttach fails (',Code,'). Check your key code.'
        STOP
      END IF

C     *** connect to POP3 server

      WRITE(*,*) 'Connecting to ', Pop3Host
      Code = seePop3Connect( VAL(0),    ! channel 0
     1    VAL(LOC(Pop3Host)),           ! POP3 host name
     2    VAL(LOC(Pop3User)),           ! POP3 user
     3    VAL(LOC(Pop3Pass)) )          ! POP3 password
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seePop3Connect returns error ', Code
        CALL ErrorExit(Code)
      END IF

C     *** get # messages waiting

      NbrMsg = seeGetEmailCount(VAL(0))

      WRITE(*,*) NbrMsg, ' messages waiting.'
      IF(NbrMsg .LT. 0) THEN
        Call ErrorExit(0)
      END IF

C     *** get message number to read
      WRITE(*,*) 'Enter message number to read on following line.'
      READ(*,*) MsgNbr

      IF((MsgNbr.LE.0).OR.(MsgNbr.GT.NbrMsg)) THEN
        WRITE(*,*) 'Message number out of range'
        Call ErrorExit(0)
      END IF


C     *** read message
      MsgSize = seeGetEmailSize(VAL(0),VAL(MsgNbr));
      WRITE(*,*) 'Message',MsgNbr,' has',MsgSize,' bytes.'
C     *** construct filename
      FileName = 'email00.mai' // CHAR(0)
      FileName(6:6) = CHAR(ICHAR('0')+MsgNbr/10)
      FileName(7:7) = CHAR(ICHAR('0')+MOD(MsgNbr,10))
      WRITE(*,*) 'Saving as ', FileName

C     *** disable AUTO CALL
      Code = seeIntegerParam(VAL(0), VAL(SEE_AUTO_CALL_DRIVER), VAL(0) )

C     *** setup to download email
      Code = seeGetEmailFile(VAL(0), VAL(MsgNbr), VAL(LOC(FileName)),
     1             VAL(LOC(EmailDir)),  VAL(LOC(AttachDir)) )
      IF(NbrMsg .LT. 0) THEN
        Call ErrorExit(Code)
      END IF

C     *** call driver to download email
      Counter = 0
  100 Code = seeDriver(VAL(0))
C     *** error ?
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeDriver returns error ', Code
        CALL ErrorExit(Code)
      END IF
C     *** good return code ?
      IF (Code .GT. 0) THEN
C       *** don't count wait states
        IF (Code .NE. 9999) THEN
C         *** print byte count every 25'th call
          Counter = Counter + 1
          IF (Counter .EQ. 25) THEN
            MsgSize = seeStatistics(VAL(0),
     1                              VAL(SEE_GET_TOTAL_BYTES_READ))
            WRITE(*,*) MsgSize, ' bytes read.'
            Counter = 0
          END IF
        END IF
        GOTO 100
      END IF
C     *** Code must be 0 (Driver is done)
      WRITE(*,*) 'Done.'

C     *** enable AUTO CALL & close connection
      Code = seeIntegerParam(VAL(0), VAL(SEE_AUTO_CALL_DRIVER), VAL(1) )
      Code = seeClose(VAL(0))

C     *** release SEE
      Code = seeRelease()

      STOP
      END

C     *** Error exit subroutine

      SUBROUTINE ErrorExit(ErrCode)
      INTEGER*4 ErrCode
      CHARACTER*64 Buffer
      INTEGER*4 Code
      IF(ErrCode.LT.0) THEN
C       *** clear Buffer
        Buffer = REPEAT(' ', 64)
C       *** get error text into Buffer & print message
        Code = seeErrorText(VAL(0), VAL(ErrCode),
     1                      VAL(LOC(Buffer)),VAL(64))
        WRITE(*,*) Buffer
      END IF
      Code = seeClose(VAL(0))
      Code = seeRelease()
      STOP
      END
