/*
**  READS.C [edit EMAIL.H before compiling]
**
**  This program reads all email message
**  and saves them to disk.
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "see.h"
#include "keycode.h"
#include "email.h"

#define QUOTE 0x22

static char Buffer[1024];

void ErrorExit(int Code)
{seeErrorText(0,Code,(LPSTR)Buffer,512);
 printf("SEE Error %d: %s\n", Code, Buffer);
 seeClose(0);
 seeRelease();
 exit(1);
}

void main(void)
{int i, Code;
 int Version;
 int Count;
 int MsgNbr;
 long MsgSize;
 long BytesRead;
 static char Filename[65];

 /* attach SEE */
 Code = seeAttach(1, SEE_KEY_CODE);
 if(Code<0) ErrorExit(Code);
 /* display parameters */
 Version = seeStatistics(0,SEE_GET_VERSION);
 printf("SEE4C Version %1d.%1d.%1d\n",0x0f&(Version>>8),0x0f&(Version>>4),0x0f&Version);
 printf("Server : %s\n",(LPSTR)POP3_HOST_NAME);
 printf("  User : %s\n",(LPSTR)POP3_USER_NAME);
 printf("  Pass : %s\n",(LPSTR)POP3_PASSWORD);

 /* define diagnostics log file */
 ///seeStringParam(0,SEE_LOG_FILE, (LPSTR)"reads.log");
 /* prefix file names with "1-", "2-", etc for all attachments */
 seeIntegerParam(0,SEE_FILE_PREFIX, 1);
 /* decode unnamed attachments (if any) */
 seeIntegerParam(0, SEE_DECODE_UNNAMED, 1);
 /* connect to POP3 server */
 printf("Connecting to '%s'\n", (LPSTR)POP3_HOST_NAME);
 Code = seePop3Connect(0,
    (LPSTR)POP3_HOST_NAME,             /* POP3 server */
    (LPSTR)POP3_USER_NAME,             /* user */
    (LPSTR)POP3_PASSWORD);             /* Password */
 if(Code<0) ErrorExit(Code);
 /* get # messages waiting  */
 puts("Getting message count...");
 Count = seeGetEmailCount(0);
 if(Count<0) ErrorExit(Count);
 printf("%d messages waiting.\n", Count);
 /* any email waiting ? */
 if(Count==0)
   {printf("No messages waiting\n");
    seeClose(0);
    seeRelease();
    exit(1);
   }
 /* read email messages */
 for(MsgNbr=1;MsgNbr<=Count;MsgNbr++)
   {/* read message  */
    MsgSize = seeGetEmailSize(0,MsgNbr);
    if(MsgSize<0) ErrorExit((int)MsgSize);
    /////printf("Message %d has %ld bytes\n", MsgNbr, MsgSize);
    /* turn off AUTO CALL driver */
    seeIntegerParam(0,SEE_AUTO_CALL_DRIVER, 0);
    /////printf("Reading message %d...\n",MsgNbr);
    /* construct filename */
    wsprintf((LPSTR)Filename,(LPSTR)"email%1d.mai",MsgNbr);
    printf("Saving message %d to '%s'\n", MsgNbr, Filename);
    Code = seeGetEmailFile(0,MsgNbr, Filename, "c:\\temp", "c:\\temp");
    /////Code = seeGetEmailFile(0,MsgNbr, Filename, ".", ".");
    if(Code<0) ErrorExit(Code);
    /* run the driver */
    for(i=0;;i++)
      {Code = seeDriver(0);
       if(Code<0) ErrorExit(Code);
       if(((i%10)==9)||(Code==0))
         {/* display progress on last call & every 10th call to seeDriver(0) */
          BytesRead = (long) seeStatistics(0,SEE_GET_TOTAL_BYTES_READ);
          printf("%ld bytes read.\r",BytesRead);
         }
       if(Code==0) break;
       }
    printf("\n");
    /* turn AUTO CALL back on */
    seeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 1);
#if 0
    /* delete this message */
    printf("Deleting message %d\n", MsgNbr);
    Code = seeDeleteEmail(0,MsgNbr);
    if(Code<0) ErrorExit(Code);
#endif
   }
 seeStringParam(0, SEE_LOG_FILE, (LPSTR)"READS.LOG");
 printf("Releasing SEE\n");
 seeClose(0);
 seeRelease();
 printf("Done\n");
} /* end main */


