      PROGRAM READS
C
C     Compile and link with
C
C        amake -f reads._a_
C
      IMPLICIT NONE
      INCLUDE 'SEE4F.INC'
      INCLUDE 'KEYCODE.INC'

      CHARACTER*64 Pop3Host
      CHARACTER*64 Pop3User
      CHARACTER*64 Pop3Pass
      CHARACTER*40 FileName
      CHARACTER*40 EmailDir
      CHARACTER*40 AttachDir

      INTEGER*4 I
      INTEGER*4 Code
      INTEGER*4 NbrMsg
      INTEGER*4 MsgSize

C     *** IMPORTANT *****************************************
C     *** Edit these next 3 lines with your POP3 server name,
C     *** user name and password. For more info, see the
C     *** Users Manual (SEE4F_U.TXT)
C     *******************************************************

      Pop3Host = 'pop3_host_name' // CHAR(0)
      Pop3User = 'pop3_user_name' // CHAR(0)
      Pop3Pass = 'pop3_password'  // CHAR(0)

C     *** specify directories for email and for attachments
      EmailDir  = 'c:\temp' // CHAR(0)
      AttachDir = 'c:\temp' // CHAR(0)

C     *** attach SEE
      Code = seeAttach(VAL(1), VAL(SEE_KEY_CODE))
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeAttach fails (',Code,'). Check your key code.'
        STOP
      END IF

C     *** connect to POP3 server

      WRITE(*,*) 'Connecting to ', Pop3Host
      Code = seePop3Connect( VAL(0),    ! channel 0
     1    VAL(LOC(Pop3Host)),           ! POP3 host name
     2    VAL(LOC(Pop3User)),           ! POP3 user
     3    VAL(LOC(Pop3Pass)) )          ! POP3 password
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seePop3Connect returns error ', Code
        CALL ErrorExit(Code)
      END IF

C     *** get # messages waiting

      NbrMsg = seeGetEmailCount(VAL(0))
      WRITE(*,*) NbrMsg, ' messages waiting.'

      IF(NbrMsg .LT. 0) THEN
        Call ErrorExit(NbrMsg)
      END IF

      IF(NbrMsg.GT.0) THEN
        DO 199 I = 1, NbrMsg
C          *** read message I
           WRITE(*,*) 'Message', I
           MsgSize = seeGetEmailSize(VAL(0),VAL(I));
           WRITE(*,*) 'Message',I,' has',MsgSize,' bytes.'
C          *** construct filename
           FileName = 'email00.mai' // CHAR(0)
           FileName(6:6) = CHAR(ICHAR('0')+I/10)
           FileName(7:7) = CHAR(ICHAR('0')+MOD(I,10))
           WRITE(*,*) 'Saving ', FileName
C          *** download the email
           Code = seeGetEmailFile(VAL(0), VAL(I), VAL(LOC(FileName)),
     1             VAL(LOC(EmailDir)),  VAL(LOC(AttachDir)) )
           IF(Code .LT. 0) THEN
             WRITE(*,*) 'seeGetEmailFile returns error '
             CALL ErrorExit(Code)
           END IF
C          *** delete the email
           Code = seeDeleteEmail(VAL(0), VAL(I))
           IF(Code .LT. 0) THEN
             WRITE(*,*) 'seeDelEmail returns error '
             CALL ErrorExit(Code)
           ELSE
             WRITE(*,*) 'Deleted.'
           END IF
  199   CONTINUE
      END IF

C     *** close connection
      Code = seeClose(VAL(0))

C     *** release SEE
      Code = seeRelease()

      STOP
      END

C     *** Error exit subroutine

      SUBROUTINE ErrorExit(ErrCode)
      INTEGER*4 ErrCode
      CHARACTER*64 Buffer
      INTEGER*4 Code
      IF(ErrCode.LT.0) THEN
C       *** clear Buffer
        Buffer = REPEAT(' ', 64)
C       *** get error text into Buffer & print message
        Code = seeErrorText(VAL(0), VAL(ErrCode),
     1                      VAL(LOC(Buffer)),VAL(64))
        WRITE(*,*) Buffer
      END IF
      Code = seeClose(VAL(0))
      Code = seeRelease()
      STOP
      END
