      PROGRAM STAT
C
C     Compile and link with
C
C        amake -f stat._a_
C
      IMPLICIT NONE
      INCLUDE 'SEE4F.INC'
      INCLUDE 'KEYCODE.INC'

      CHARACTER*64 Pop3Host
      CHARACTER*64 Pop3User
      CHARACTER*64 Pop3Pass

      INTEGER*4 Code
      INTEGER*4 NbrMsg

C     *** IMPORTANT *****************************************
C     *** Edit these next 3 lines with your POP3 server name,
C     *** user name and password. For more info, see the
C     *** Users Manual (SEE4F_U.TXT)
C     *******************************************************

      Pop3Host = 'pop3_host_name' // CHAR(0)
      Pop3User = 'pop3_user_name' // CHAR(0)
      Pop3Pass = 'pop3_password'  // CHAR(0)

C     *** attach SEE
      Code = seeAttach(VAL(1), VAL(SEE_KEY_CODE))
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seeAttach fails (',Code,'). Check your key code.'
        STOP
      END IF

C     *** connect to POP3 server

      WRITE(*,*) 'Connecting to ', Pop3Host
      Code = seePop3Connect( VAL(0),    ! channel 0
     1    VAL(LOC(Pop3Host)),           ! POP3 host name
     2    VAL(LOC(Pop3User)),           ! POP3 user
     3    VAL(LOC(Pop3Pass)) )          ! POP3 password
      IF(Code .LT. 0) THEN
        WRITE(*,*) 'seePop3Connect returns error ', Code
        CALL ErrorExit(Code)
      END IF

C     *** get # messages waiting

      NbrMsg = seeGetEmailCount(VAL(0))
      IF(NbrMsg .LT. 0) THEN
        CALL ErrorExit(0)
      END IF

      WRITE(*,*) NbrMsg, ' messages waiting'

C     *** close connection
      Code = seeClose(VAL(0))

C     *** release SEE
      Code = seeRelease()

      STOP
      END

C     *** Error exit subroutine

      SUBROUTINE ErrorExit(ErrCode)
      INTEGER*4 ErrCode
      CHARACTER*64 Buffer
      INTEGER*4 Code
      IF(ErrCode.LT.0) THEN
C       *** clear Buffer
        Buffer = REPEAT(' ', 64)
C       *** get error text into Buffer & print message
        Code = seeErrorText(VAL(0), VAL(ErrCode),
     1                      VAL(LOC(Buffer)),VAL(64))
        WRITE(*,*) Buffer
      END IF
      Code = seeClose(VAL(0))
      Code = seeRelease()
      STOP
      END

