/*
**  STATUS.C [edit EMAIL.H before compiling]
**
**  This program displays the header from each
**  email message on the POP3 server.
*/

#include <windows.h>
#include <stdio.h>
#include "see.h"
#include "keycode.h"
#include "email.h"

#define BUFF_SIZE   2048
#define TEMP_SIZE    130

#define CHAN 0

static char Buffer[BUFF_SIZE];
static char Temp[TEMP_SIZE];

void ErrorExit(int Code)
{seeErrorText(CHAN,Code,(LPSTR)Buffer,512);
 printf("SEE Error %d: %s\n", Code, Buffer);
 seeClose(CHAN);
 exit(1);
}

void main(void)
{int i, n;
 int Code;
 int NbrMsg;
 int Version;
 long MsgSize;
 /* attach SEE */
 Code = seeAttach(1, SEE_KEY_CODE);
 if(Code<0) ErrorExit(Code);
 Version = seeStatistics(CHAN,SEE_GET_VERSION);
 printf("SEE4C Version %1d.%1d.%1d\n",0x0f&(Version>>8),0x0f&(Version>>4),0x0f&Version);

 /* define diagnostics log file */
 seeStringParam(CHAN, SEE_LOG_FILE, (LPSTR)"status.log");
 /* connect to POP3 server */
 printf("Connecting to %s ...",(LPSTR)POP3_HOST_NAME);
 Code = seePop3Connect(CHAN,
    (LPSTR)POP3_HOST_NAME,             /* POP3 server */
    (LPSTR)POP3_USER_NAME,             /* user */
    (LPSTR)POP3_PASSWORD);             /* Password */
 if(Code>=0) printf("OK\n");
 else ErrorExit(Code);
 /* display server IP address */
 seeDebug(CHAN, SEE_GET_SERVER_IP, (LPSTR)Temp, TEMP_SIZE);
 printf("Server IP address is %s\n", (LPSTR)Temp);
 /* display local IP address */
 seeDebug(CHAN, SEE_GET_LOCAL_IP, (LPSTR)Temp, TEMP_SIZE);
 printf("Local IP address is %s\n", (LPSTR)Temp);
 /* get # messages waiting  */
 puts("Getting message count...");
 NbrMsg = seeGetEmailCount(CHAN);
 if(NbrMsg<0) ErrorExit(NbrMsg);
 printf("%d messages waiting.\n", NbrMsg);
 /* read message headers */
 for(i=1;i<=NbrMsg;i++)
   {/* read message i */
    printf("---[ Message %d, ",i);
    Code = seeGetEmailLines(CHAN, i, 0, (LPSTR)Buffer, BUFF_SIZE);
    if(Code<0) ErrorExit(Code);
    MsgSize = seeGetEmailSize(CHAN, i);
    printf("%d bytes ]-------------------------------\n",MsgSize);
    ///Buffer[Code] = '\0';
    /* display "DATE: " line */
    n = seeExtractText((LPSTR)Buffer, "Date: ", (LPSTR)Temp, TEMP_SIZE);
    if(n>0) printf("%s", (LPSTR)Temp);
    /* display "FROM: " line */
    n = seeExtractText((LPSTR)Buffer, "From: ", (LPSTR)Temp, TEMP_SIZE);
    if(n>0) printf("%s", (LPSTR)Temp);
    /* display "SUBJECT: " line */
    n = seeExtractText((LPSTR)Buffer, "Subject: ", (LPSTR)Temp, TEMP_SIZE);
    if(n>0) printf("%s", (LPSTR)Temp);
    /* display "STATUS: " line */
    n = seeExtractText((LPSTR)Buffer, "Status:", (LPSTR)Temp, TEMP_SIZE);
    if(n>0) printf("%s", (LPSTR)Temp);
    /* get server's unique ID string for this email */
    n = seeGetEmailUID(0, i, (LPSTR)Temp, TEMP_SIZE);
    if(n>0)
      {Temp[n] = '\0';
       printf("UID:%s", (LPSTR)Temp+3);
      }
    /* Note: Cannot get attachment filenames since email is not read */
   }
 if(NbrMsg>0)
   printf("----------------------------------------------------\n");
 seeClose(CHAN);
 seeRelease();
} /* end main */


